# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class EmissionRecordRequest(Model):
    """EmissionRecordRequest.

    All required parameters must be populated in order to send to Azure.

    :param emission_source_id: Required. The Emission Source this record will
     be assigned to <span class='property-internal'>Required</span>
    :type emission_source_id: int
    :param begin_date: Required. The begin date for this record <span
     class='property-internal'>Required</span>
    :type begin_date: datetime
    :param end_date: Required. The end date for this record <span
     class='property-internal'>Required</span>
    :type end_date: datetime
    :param vendor_id: The supplier for this record <span
     class='property-internal'>Required (defined)</span>
    :type vendor_id: int
    :param record_type_id: Required. The type of this record. Valid values
     are:
     1 - Use
     2 - Cost
     3 - Direct/Offset <span class='property-internal'>Required</span> <span
     class='property-internal'>One of 1, 2, 3 </span>
    :type record_type_id: int
    :param scope_category_id: Required. The scope category for this record
     <span class='property-internal'>Required</span>
    :type scope_category_id: int
    :param factor_id: Required. The factor for this record <span
     class='property-internal'>Required</span>
    :type factor_id: int
    :param quantity: The use that is being tracked by this record.
     This value is required if RecordTypeId is set to 1 (Use) or 3
     (Direct/Offset),
     but must be left null if RecordTypeId is set to 2 (Cost). <span
     class='property-internal'>Required when RecordTypeId is set to 1, or
     3</span>
    :type quantity: float
    :param quantity_unit_id: The unit for the use being tracked by this
     record.
     This value is required if RecordTypeId is set to 1 (Use) or 3
     (Direct/Offset),
     but must be left null if RecordTypeId is set to 2 (Cost). <span
     class='property-internal'>Required when RecordTypeId is set to 1, or
     3</span>
    :type quantity_unit_id: int
    :param cost: The cost for this record
     Required if RecordTypeId is set to 2 (Cost), otherwise it is optional.
     <span class='property-internal'>Required when RecordTypeId is set to
     2</span>
    :type cost: float
    :param cost_unit_id: The unit for this record's cost.
     Required if RecordTypeId is set to 2 (Cost), otherwise it is optional.
     <span class='property-internal'>Required when RecordTypeId is set to
     2</span>
    :type cost_unit_id: int
    :param note: The note for this record <span class='property-internal'>Must
     be between 0 and 255 characters</span> <span
     class='property-internal'>Required (defined)</span>
    :type note: str
    :param attachment: The attachment for this record <span
     class='property-internal'>Must be between 0 and 260 characters</span>
     <span class='property-internal'>Required (defined)</span>
    :type attachment: str
    """

    _validation = {
        'emission_source_id': {'required': True},
        'begin_date': {'required': True},
        'end_date': {'required': True},
        'record_type_id': {'required': True},
        'scope_category_id': {'required': True},
        'factor_id': {'required': True},
        'note': {'max_length': 255, 'min_length': 0},
        'attachment': {'max_length': 260, 'min_length': 0},
    }

    _attribute_map = {
        'emission_source_id': {'key': 'emissionSourceId', 'type': 'int'},
        'begin_date': {'key': 'beginDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
        'vendor_id': {'key': 'vendorId', 'type': 'int'},
        'record_type_id': {'key': 'recordTypeId', 'type': 'int'},
        'scope_category_id': {'key': 'scopeCategoryId', 'type': 'int'},
        'factor_id': {'key': 'factorId', 'type': 'int'},
        'quantity': {'key': 'quantity', 'type': 'float'},
        'quantity_unit_id': {'key': 'quantityUnitId', 'type': 'int'},
        'cost': {'key': 'cost', 'type': 'float'},
        'cost_unit_id': {'key': 'costUnitId', 'type': 'int'},
        'note': {'key': 'note', 'type': 'str'},
        'attachment': {'key': 'attachment', 'type': 'str'},
    }

    def __init__(self, **kwargs):
        super(EmissionRecordRequest, self).__init__(**kwargs)
        self.emission_source_id = kwargs.get('emission_source_id', None)
        self.begin_date = kwargs.get('begin_date', None)
        self.end_date = kwargs.get('end_date', None)
        self.vendor_id = kwargs.get('vendor_id', None)
        self.record_type_id = kwargs.get('record_type_id', None)
        self.scope_category_id = kwargs.get('scope_category_id', None)
        self.factor_id = kwargs.get('factor_id', None)
        self.quantity = kwargs.get('quantity', None)
        self.quantity_unit_id = kwargs.get('quantity_unit_id', None)
        self.cost = kwargs.get('cost', None)
        self.cost_unit_id = kwargs.get('cost_unit_id', None)
        self.note = kwargs.get('note', None)
        self.attachment = kwargs.get('attachment', None)
