# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class EmissionRecordResponse(Model):
    """EmissionRecordResponse.

    :param emission_record_id: The record identifier
    :type emission_record_id: int
    :param bill_id: The bill identifier, if this record originated from a bill
     in UtilityManagement
    :type bill_id: int
    :param emission_source:
    :type emission_source: ~energycap.sdk.models.EmissionSourceChild
    :param vendor:
    :type vendor: ~energycap.sdk.models.VendorChild
    :param start_date: The start date for the record
    :type start_date: datetime
    :param end_date: The end date for the record
    :type end_date: datetime
    :param billing_period: The bill's billing period, if this record
     originated from a bill in UtilityManagement
    :type billing_period: int
    :param emission_record_type:
    :type emission_record_type: ~energycap.sdk.models.EmissionRecordType
    :param scope_category:
    :type scope_category: ~energycap.sdk.models.GHGScopeCategoryChild
    :param factor:
    :type factor: ~energycap.sdk.models.GHGFactorChild
    :param quantity:
    :type quantity: ~energycap.sdk.models.ValueWithUnit
    :param cost:
    :type cost: ~energycap.sdk.models.ValueWithUnit
    :param total_emissions: The total GHG emissions for this record in kgCO2e.
    :type total_emissions: float
    :param emission_values: The GHG emissions for this record, split by
     greenhouse gas type
    :type emission_values: list[~energycap.sdk.models.GHGGroupEmissions]
    :param note: The note for this record
    :type note: str
    :param attachment: The attachment for this record
    :type attachment: str
    :param created_by:
    :type created_by: ~energycap.sdk.models.UserChild
    :param created_date: The date this record was created
    :type created_date: datetime
    :param modified_by:
    :type modified_by: ~energycap.sdk.models.UserChild
    :param modified_date: The date this record was last modified
    :type modified_date: datetime
    :param creation_method: The emission record creation method
    :type creation_method: str
    """

    _attribute_map = {
        'emission_record_id': {'key': 'emissionRecordId', 'type': 'int'},
        'bill_id': {'key': 'billId', 'type': 'int'},
        'emission_source': {'key': 'emissionSource', 'type': 'EmissionSourceChild'},
        'vendor': {'key': 'vendor', 'type': 'VendorChild'},
        'start_date': {'key': 'startDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
        'billing_period': {'key': 'billingPeriod', 'type': 'int'},
        'emission_record_type': {'key': 'emissionRecordType', 'type': 'EmissionRecordType'},
        'scope_category': {'key': 'scopeCategory', 'type': 'GHGScopeCategoryChild'},
        'factor': {'key': 'factor', 'type': 'GHGFactorChild'},
        'quantity': {'key': 'quantity', 'type': 'ValueWithUnit'},
        'cost': {'key': 'cost', 'type': 'ValueWithUnit'},
        'total_emissions': {'key': 'totalEmissions', 'type': 'float'},
        'emission_values': {'key': 'emissionValues', 'type': '[GHGGroupEmissions]'},
        'note': {'key': 'note', 'type': 'str'},
        'attachment': {'key': 'attachment', 'type': 'str'},
        'created_by': {'key': 'createdBy', 'type': 'UserChild'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'modified_by': {'key': 'modifiedBy', 'type': 'UserChild'},
        'modified_date': {'key': 'modifiedDate', 'type': 'iso-8601'},
        'creation_method': {'key': 'creationMethod', 'type': 'str'},
    }

    def __init__(self, **kwargs):
        super(EmissionRecordResponse, self).__init__(**kwargs)
        self.emission_record_id = kwargs.get('emission_record_id', None)
        self.bill_id = kwargs.get('bill_id', None)
        self.emission_source = kwargs.get('emission_source', None)
        self.vendor = kwargs.get('vendor', None)
        self.start_date = kwargs.get('start_date', None)
        self.end_date = kwargs.get('end_date', None)
        self.billing_period = kwargs.get('billing_period', None)
        self.emission_record_type = kwargs.get('emission_record_type', None)
        self.scope_category = kwargs.get('scope_category', None)
        self.factor = kwargs.get('factor', None)
        self.quantity = kwargs.get('quantity', None)
        self.cost = kwargs.get('cost', None)
        self.total_emissions = kwargs.get('total_emissions', None)
        self.emission_values = kwargs.get('emission_values', None)
        self.note = kwargs.get('note', None)
        self.attachment = kwargs.get('attachment', None)
        self.created_by = kwargs.get('created_by', None)
        self.created_date = kwargs.get('created_date', None)
        self.modified_by = kwargs.get('modified_by', None)
        self.modified_date = kwargs.get('modified_date', None)
        self.creation_method = kwargs.get('creation_method', None)
